<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\Feature\FeatureInterface;
use Ivoz\Provider\Domain\Model\FeaturesRelCompany\FeaturesRelCompany;
use Ivoz\Provider\Domain\Model\FeaturesRelCompany\FeaturesRelCompanyInterface;
use Ivoz\Provider\Domain\Model\FeaturesRelCompany\FeaturesRelCompanyRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * FeaturesRelCompanyDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<FeaturesRelCompany>
 */
class FeaturesRelCompanyDoctrineRepository extends ServiceEntityRepository implements FeaturesRelCompanyRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, FeaturesRelCompany::class);
    }

    /**
     * @return string[]
     */
    public function findFeatureIdensByCompanyId(int $companyId): array
    {
        $qb = $this->createQueryBuilder('self');
        $expr = $qb->expr();

        $qb
            ->select(
                'self, feature'
            )
            ->innerJoin(
                'self.feature',
                'feature'
            )
            ->where(
                $expr->eq('self.company', $companyId)
            );

        /** @var FeaturesRelCompanyInterface[] $response */
        $response = $qb
            ->getQuery()
            ->getResult();

        $features = array_map(
            fn (FeaturesRelCompanyInterface $featureRelCompany) => $featureRelCompany->getFeature()->getIden(),
            $response
        );

        return $features;
    }
}
