<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\User\UserInterface;
use Ivoz\Provider\Domain\Model\Voicemail\Voicemail;
use Ivoz\Provider\Domain\Model\Voicemail\VoicemailInterface;
use Ivoz\Provider\Domain\Model\Voicemail\VoicemailRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * VoicemailDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<Voicemail>
 */
class VoicemailDoctrineRepository extends ServiceEntityRepository implements VoicemailRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Voicemail::class);
    }

    /**
     * @param UserInterface $user
     * @return VoicemailInterface[]
     */
    public function getAvailableVoicemailsForUser(UserInterface $user): array
    {
        $company = $user->getCompany();

        $qb = $this->createQueryBuilder('self');
        $expression = $qb->expr();

        $query = $qb
            ->where(
                $expression->eq('self.company', $company->getid())
            )->andWhere(
                $expression->eq('self.enabled', true)
            )->getQuery();

        return $query->getResult();
    }
}
